<template>
   <v-container fluid fill-height>
      <v-layout align-center justify-center>
         <v-flex xs12 sm8 md4>
            <v-card class="elevation-12">
               <v-toolbar dark color="primary">
                  <v-toolbar-title>Connexion</v-toolbar-title>
               </v-toolbar>
               <v-card-text>
                  <v-form ref="form" class="mx-2" lazy-validation>
                     <v-text-field
                        v-model="email"
                        @keydown="onEnter"
                        :rules="emailRules"
                        prepend-icon="mdi-email"
                        name="email"
                        label="E-mail"
                        type="text"
                        required
                     ></v-text-field>
                     <v-text-field
                        v-model="password"
                        @keydown="onEnter"
                        :rules="passwordRules"
                        id="password"
                        prepend-icon="mdi-lock"
                        name="password"
                        label="Mots de passe"
                        type="password"
                        required
                     ></v-text-field>
                     <div  class="text-end">
                        <router-link to="register">Inscription</router-link>
                     </div>
                  </v-form>
               </v-card-text>
               <v-card-actions>
                  <v-spacer></v-spacer>
                  <v-btn color="primary" @click="submitForm">Valider</v-btn>
               </v-card-actions>
            </v-card>
         </v-flex>
      </v-layout>
   </v-container>
</template>

<script>
import AuthenticationService from '../services/AuthenticationService'
import EventBusEnum from '../enum/EventBusEnum'
import Utils from '../helpers/Utils'
export default {
   name: 'Login',

   data () {
      return {
         email: '',
         password: '',
         emailRules: [
            v => !!v || 'E-mail is required',
            v => /^(([^<>()[\]\\.,;:\s@']+(\.[^<>()\\[\]\\.,;:\s@']+)*)|('.+'))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/.test(v) || 'L\'e-mail doit être valide',
         ],
         passwordRules: [
            v => !!v || 'Password is required',
            v => /(?=.*\d)(?=.*[a-z])(?=.*[A-Z]).{6,}/.test(v) || 'Le mots de passe doit être constitué d\'au moins 6 caractères, contenir au moins une lettre minuscule, un nombre, un caractère spécial et une lettre majuscule',
         ],
      }
   },
   methods: {
      onEnter (e) {
         if(e.keyCode === 13) {
            this.submitForm()
         }
      },
      submitForm () {
         const isValid = this.$refs.form.validate();
         if(isValid) {
            AuthenticationService.login({email: this.email, password: this.password})
            .then(Utils.handleResponse)
            .then(response => {  
               if(response.success) {        
                  localStorage.setItem("token", JSON.stringify(response.data.token));
                  this.$router.push('/')
               } else {
                  Utils.emitMethod(EventBusEnum.EVENT_SNACKBAR, {timeout:3000, message: response.message, show: true, color: 'red'})
               }

            }).catch(function(e) {
               // Utils.emitMethod(EventBusEnum.EVENT_SNACKBAR, {timeout:3000, message: e.message, show: true, color: 'red'})
               Utils.emitMethod(EventBusEnum.EVENT_SNACKBAR, {timeout:3000, message: "Identifiant ou mots de passe incorrect", show: true, color: 'red'})
            })
         }
      },
   },
};
</script>

<style></style>
